import * as React from 'react';
import ScalingCellSizeAndPositionManager from './utils/ScalingCellSizeAndPositionManager';
export interface CellPosition {
    columnIndex?: number;
    rowIndex?: number;
}
export interface CellRendererParams {
    columnIndex: number;
    isScrolling: boolean;
    isVisible: boolean;
    key: string;
    parent: any;
    rowIndex: number;
    style: any;
}
export declare type CellRenderer = (props: CellRendererParams) => React.ReactElement<any>;
export interface CellCache {
    [key: string]: React.ReactElement<any>;
}
export interface StyleCache {
    [key: string]: any;
}
export interface CellRangeRendererParams {
    cellCache: CellCache;
    cellRenderer: CellRenderer;
    columnSizeAndPositionManager: ScalingCellSizeAndPositionManager;
    columnStartIndex: number;
    columnStopIndex: number;
    deferredMeasurementCache?: any;
    horizontalOffsetAdjustment: number;
    isScrolling: boolean;
    isScrollingOptOut: boolean;
    parent: any;
    rowSizeAndPositionManager: ScalingCellSizeAndPositionManager;
    rowStartIndex: number;
    rowStopIndex: number;
    scrollLeft: number;
    scrollTop: number;
    styleCache: StyleCache;
    verticalOffsetAdjustment: number;
    visibleColumnIndices: any;
    visibleRowIndices: any;
}
export declare type CellRangeRenderer = (params: CellRangeRendererParams) => React.ReactElement<any>[];
export declare type CellSizeGetter = (params: {
    index: number;
}) => number;
export declare type CellSize = CellSizeGetter | number;
export declare type NoContentRenderer = () => React.ReactElement<any> | null;
export interface Scroll {
    clientHeight: number;
    clientWidth: number;
    scrollHeight: number;
    scrollLeft: number;
    scrollTop: number;
    scrollWidth: number;
}
export interface ScrollbarPresenceChange {
    horizontal: boolean;
    vertical: boolean;
    size: number;
}
export interface RenderedSection {
    columnOverscanStartIndex: number;
    columnOverscanStopIndex: number;
    columnStartIndex: number;
    columnStopIndex: number;
    rowOverscanStartIndex: number;
    rowOverscanStopIndex: number;
    rowStartIndex: number;
    rowStopIndex: number;
}
export interface OverscanIndicesGetterParams {
    direction: 'horizontal' | 'vertical';
    scrollDirection: -1 | 1;
    cellCount: number;
    overscanCellsCount: number;
    startIndex: number;
    stopIndex: number;
}
export interface OverscanIndices {
    overscanStartIndex: number;
    overscanStopIndex: number;
}
export declare type OverscanIndicesGetter = (params: OverscanIndicesGetterParams) => OverscanIndices;
export declare type Alignment = 'auto' | 'end' | 'start' | 'center';
export interface VisibleCellRange {
    start?: number;
    stop?: number;
}
//# sourceMappingURL=types.d.ts.map